#![allow(deprecated)]
use std::fmt;
use std::str;
/// The group by option for the time series plot. A RANGE group by option means that all channels on the
/// same time range are plotted together, while a VARIABLE group by option means that all time ranges
/// for the same channel are plotted together.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum ComparisonTimeSeriesGroupBy {
    #[serde(rename = "RANGE")]
    Range,
    #[serde(rename = "VARIABLE")]
    Variable,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl ComparisonTimeSeriesGroupBy {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            ComparisonTimeSeriesGroupBy::Range => "RANGE",
            ComparisonTimeSeriesGroupBy::Variable => "VARIABLE",
            ComparisonTimeSeriesGroupBy::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for ComparisonTimeSeriesGroupBy {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for ComparisonTimeSeriesGroupBy {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for ComparisonTimeSeriesGroupBy {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<ComparisonTimeSeriesGroupBy, conjure_object::plain::ParseEnumError> {
        match v {
            "RANGE" => Ok(ComparisonTimeSeriesGroupBy::Range),
            "VARIABLE" => Ok(ComparisonTimeSeriesGroupBy::Variable),
            v => v.parse().map(|v| ComparisonTimeSeriesGroupBy::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for ComparisonTimeSeriesGroupBy {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<ComparisonTimeSeriesGroupBy, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the ComparisonTimeSeriesGroupBy enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
